namespace WICS.Generator.MSBuildTasks
{
	using System;
	using System.Collections.Generic;
	using System.Text;

	using Microsoft.Build.Framework;
	using Microsoft.Build.Utilities;

	public class Wait: Task
	{
		private int milliseconds;

		/// <summary>
		/// The time in milliseconds to wait.
		/// </summary>
		public int Milliseconds
		{
			get { return milliseconds; }
			set { milliseconds = value; }
		}

		/// <summary>
		/// Executes the tasks.
		/// </summary>
		/// <returns>A value of true if it has completed.</returns>
		public override bool Execute ( )
		{
			Log.LogMessage ( MessageImportance.High, "The thread is waiting {0} milliseconds till it continues.", this.Milliseconds );
			System.Threading.Thread.Sleep ( this.Milliseconds );

			return !Log.HasLoggedErrors;
		}
	}
}