namespace WICS.Generator.Processors
{
	using System;
	using System.Xml;

	using Microsoft.Build.Framework;

	/// <summary>
	/// Defines the inteface that all processors must inherit from.
	/// </summary>
	public interface IProcessor
	{
		/// <summary>
		/// Gets the element prefix that will be added to the name.
		/// </summary>
		string ElementPrefix
		{ get; }

		/// <summary>
		/// Gets or sets the <see cref="ITaskItem"/> that represents the file.
		/// </summary>
		ITaskItem File
		{ get; }

		/// <summary>
		/// Gets the namespace that will be added to the <see cref="XmlDocument"/>.
		/// </summary>
		string Namespace
		{ get; }

		/// <summary>
		/// Executes the object.
		/// </summary>
		/// <param name="writer">An <see cref="XmlWriter"/> to append to.</param>
		void Execute ( XmlWriter writer );
	}
}